//---------------------------------------------------------------------------
#include <condefs.h>
#pragma hdrstop
#define Library

#include "Filter.hxx"
#include "Complex.hxx"
#include "Signal1D.hxx"
#include "AFMHistogram.hxx"

AFMHistogram::AFMHistogram(void) {
    for (unsigned int i=0;i<65536;i++)
        data[i]=0;
}

AFMHistogram::~AFMHistogram(void) {}

void AFMHistogram::remap(const Signal1D &signal) {
    for (unsigned int i=0;i<65536;i++)
        data[i]=0;
    for (unsigned long i=0;i<signal.dimension();i++) {
        unsigned long v;
        if (signal[i].re<=(-32768)) v=0;
        if (signal[i].re>=(32767)) v=65535;
        else v=(unsigned long)(signal[i].re+32768);

        data[v]++;
    }
}

void AFMHistogram::cumul() {
    for (unsigned int i=1;i<65536;i++)
        data[i]=data[i]+data[i-1];
}

void AFMHistogram::cumulInv() {
    for (unsigned int i=65534;i>0;i=i-1)
        data[i]=data[i+1]+data[i];
}

void AFMHistogram::deriv(const AFMHistogram &src) {
    for (unsigned int i=1;i<65535;i++)
        data[i]=(src.data[i-1]-src.data[i+1])/2;
}

float AFMHistogram::lastTransition(float seuil) {
    unsigned int i=65534;

    while (data[i]<seuil) i=i-1;
    return (float)(i-32768);
}

