//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Complex.hxx"
#include "Filter.hxx"
#include "Signal1D.hxx"
#include "Lut16.hxx"
#include "AFMHistogram.hxx"
#include "MainWin.h"
#include "FilterWin.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    bitmap1=new Graphics::TBitmap;
    bitmap1->Width=256;
    bitmap1->Height=256;

    bitmap2=new Graphics::TBitmap;
    bitmap2->Width=256;
    bitmap2->Height=256;

    Canvas->Draw(10,10,bitmap1);
    Canvas->Draw(276,10,bitmap2);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    delete bitmap1;
    delete bitmap2;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
    Canvas->Draw(10,10,bitmap1);
    Canvas->Draw(276,10,bitmap2);
}

//---------------------------------------------------------------------------
void TForm1::drawSrc() {
    float pix;

    if (signalSrc.isDrawable()) {
         for (unsigned int i=0;i<256;i++)
            for (unsigned int j=0;j<256;j++) {
                pix=signalSrc.getPixNormalized(i,j,255,255);
                bitmap1->Canvas->Pixels[j][i]=lutSrc.getColor(pix);
            }
    }
    else {
         for (unsigned int i=0;i<256;i++)
            for (unsigned int j=0;j<256;j++)
                bitmap1->Canvas->Pixels[j][i]=0x00FFFFFF;
    }
    Canvas->Draw(10,10,bitmap1);
}

void TForm1::drawDest() {
    float pix;

    if (signalDest.isDrawable()) {
         for (unsigned int i=0;i<256;i++)
            for (unsigned int j=0;j<256;j++) {
                pix=signalDest.getPixNormalized(i,j,255,255);
                bitmap2->Canvas->Pixels[j][i]=lutDest.getColor(pix);
            }
    }
    else {
         for (unsigned int i=0;i<256;i++)
            for (unsigned int j=0;j<256;j++)
                bitmap2->Canvas->Pixels[j][i]=0x00FFFFFF;
    }
    Canvas->Draw(276,10,bitmap2);
}




void __fastcall TForm1::Quitter1Click(TObject *Sender)
{
    Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Ouvrir1Click(TObject *Sender)
{
    OpenDialog1->FileName="*.000";
    if (OpenDialog1->Execute()) {
        signalSrc.load(OpenDialog1->FileName.c_str());
        if (signalSrc.isDrawable()) {
            lutSrc.etal(signalSrc.min(),signalSrc.max());
        }
        drawSrc();
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TFR1Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        signalDest=signalSrc;
        signalDest.tfr();
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::TFR11Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        signalDest=signalSrc;
        signalDest.tfrInv();
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Corriger1Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        Form2->ShowModal();
        FormPaint(this);

        AFMHistogram h;
        AFMHistogram hd;
        float M;
        Signal1D noise;
        noise=signalSrc;;

        if (Form2->filter.abs)
            M=Form2->filter.seuilAbs;
        else {
            h.remap(noise);
            h.cumulInv();
            hd.deriv(h);
            M=hd.lastTransition(Form2->filter.seuilDeriv);
        }
        noise.cutMax(M);
        noise.tfr();
        noise.computeNoise(Form2->filter);
        noise.tfrInv();
        signalDest=noise;
        signalDest.dif(signalSrc,noise);
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
    signalSrc=signalDest;
    if (signalSrc.isDrawable()) {
        lutSrc.etal(signalSrc.min(),signalSrc.max());
        drawSrc();
        drawDest();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
    signalDest=signalSrc;
    if (signalDest.isDrawable()) {
        lutDest.etal(signalDest.min(),signalDest.max());
        drawSrc();
        drawDest();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
    Signal1D tmp;

    tmp=signalSrc;
    signalSrc=signalDest;
    signalDest=tmp;

    if (signalSrc.isDrawable()) {
        lutSrc.etal(signalSrc.min(),signalSrc.max());
        drawSrc();
        }
    if (signalDest.isDrawable()) {
        lutDest.etal(signalDest.min(),signalDest.max());
        drawDest();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Filtrer1Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        signalSrc.filter(Form2->filter);
    if (signalSrc.isDrawable()) {
        lutSrc.etal(signalSrc.min(),signalSrc.max());
        drawSrc();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Optionfiltre1Click(TObject *Sender)
{
    Form2->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Noise1Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        AFMHistogram h;
        AFMHistogram hd;
        float M;
        Signal1D noise;
        noise=signalSrc;;

        if (Form2->filter.abs)
            M=Form2->filter.seuilAbs;
        else {
            h.remap(noise);
            h.cumulInv();
            hd.deriv(h);
            M=hd.lastTransition(Form2->filter.seuilDeriv);
        }
        noise.cutMax(M);
        noise.tfr();
        noise.computeNoise(Form2->filter);
        noise.tfrInv();
        signalDest=noise;
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Noise2(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        signalDest=signalSrc;
        signalDest.tfr();
        signalDest.computeNoise(Form2->filter);
        signalDest.tfrInv();
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Correctionsimple1Click(TObject *Sender)
{
    if (!signalSrc.isEmpty()) {
        Form2->ShowModal();
        FormPaint(this);

        signalDest=signalSrc;
        signalDest.tfr();
        signalDest.filter(Form2->filter);
        signalDest.tfrInv();
        if (signalDest.isDrawable()) {
            lutDest.etal(signalDest.min(),signalDest.max());
            drawDest();
        }
    }
}
//---------------------------------------------------------------------------

