#ifndef _SIGNAL1D
#define _SIGNAL1D

class Signal1D {
    public:
        Signal1D();
        Signal1D(unsigned long d);
        ~Signal1D();


        void tfr();
        void tfrInv();
        void load(const char fileName[]);

        Complex operator[](unsigned long i) const;
        void dif(const Signal1D &a,const Signal1D &b);
        void operator=(const Signal1D &s);

        unsigned long dimension() const;
        float module(long i) const;
        float min() const;
        float max() const;

        float getPix(unsigned int l,unsigned int c) const;
        float getPixNormalized(unsigned int l,unsigned int c,unsigned int w,unsigned int h);
        bool isDrawable() const;
        bool isEmpty() const;

        friend ostream& operator<<(ostream &os,Signal1D &s);
        void filter(Filter f);
        void loFilter(int width);
        void autoLoFilter(int width,float delta);
        void hiFilter(int width);
        void computeNoise(Filter f);
        void cutMax(float M);


        void raz(unsigned long mini,
                 unsigned long maxi);

    protected:
        void fourierTransform(char sens);
        unsigned int expTwoDim();



    private:
        unsigned int width;
        unsigned int height;
        unsigned long dim;
        Complex *data;
        bool empty;
        bool drawable;

        char* buffer;
        unsigned long bufWidth;
    };

#endif