//---------------------------------------------------------------------------
#include <condefs.h>
#pragma hdrstop
#define Library

#include "strFile.h"
#include <string.h>

// fonction fScanFullStr
//
// Lecture dans un fichier d'une chaine de caracteres complete :
//      Une ligne composee de caracteres et terminee par '\n'
//
//  FILE* file : Id fichier (IN)
//  char str[] : Tableau de caracteres (IN)

void fScanFullStr(FILE* file,char str[]) {
	char c='0';
	int i=-1;

	while (c!='\n') {
		fscanf(file,"%c",&c);
		i++;
		str[i]=c;
	}
	str[i]='\0';
}

// fonction fFindParam
//
// positionne le pointeur d'un fichier apres une chaine de caractere
//
//  FILE* file : id fichier (IN)
//  const char paramName[] : chaine de caracteres a rechercher (IN)


void fFindParam(FILE* file,const char paramName[]) {
	char string[256];
	bool find=false;

	while (!find) {
		fScanFullStr(file,string);

		if (strcmp(paramName,string)==0)
			find=true;
	}
}

// fonction fScanIntParam
//
// Lit dans un fichier une valeur entiere correspondant a un parametre
// decrit dans une chaine de caracteres
//
// FILE* file : Id fichier (IN)
// char paramName[] : nom du parametre (IN)
// int *val : valeur de l'entier a modifier (OUT)

void fScanIntParam(FILE* file,const char paramName[],int *val) {
	char string[256];
	bool find=false;

	while (!find) {
		fScanFullStr(file,string);

		if (strncmp(paramName,string,strlen(paramName))==0) {
			sscanf(&string[strlen(paramName)],"%d",val);
			find=true;
		}
	}
}

// fonction fScanfloatParam
//
// Lit dans un fichier une valeur float correspondant a un parametre
// decrit dans une chaine de caracteres
//
// FILE* file : Id fichier (IN)
// char paramName[] : nom du parametre (IN)
// float *val : valeur du float a modifier (OUT)

void fScanFloatParam(FILE* file,const char paramName[],float *val) {
	char string[256];
	bool find=false;

	while (!find) {
		fScanFullStr(file,string);

		if (strncmp(paramName,string,strlen(paramName))==0) {
			sscanf(&string[strlen(paramName)],"%f",val);
			find=true;
		}
	}
}