#ifndef __Image__
	#define __Image__
	
	#include <stdio.h>
	#include <iostream.h>
	#define DEBUG_MODE
	
	template <class T>
	class Image
	{
		public:
			// Constructor
			Image(const int pnbColumn, const int pnbLine,
			      const int pnbComponent);
			Image(const int pnbColumn, const int pnbLine,
			      const int pnbComponent, const char *pfileName);
			
			// Destructor
			virtual ~Image();
			
			// Method
			virtual int Load(const char *pfileName);
			int Save(const char *pfileName) const;
			T *operator[](const int plineIndex) {return _img[plineIndex];};
			int nbLine() const {return _nbLine;};
			int nbColumn() const {return _nbColumn;};
			
		protected:
			// Constructor
			Image();

			// Method
			int Init(const int pnbColumn, const int pnbLine,
			         const int pnbComponent);
			int Load(FILE *pfilePtr);
			int Save(FILE *pfilePtr) const;

			// Attribute
			T **_img;
			int _nbLine;
			int _nbColumn;
			int _nbComponent;
	};
	
	#include "Image_m.hxx"
#endif
