// Constructor
ImagePGM::ImagePGM(const int pnbColumn, const int pnbLine):
          Image<unsigned char>(pnbColumn, pnbLine, PGM_NB_COMPONENT)
{
	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans le constructeur 1 de ImagePGM\n";
	#endif
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie du constructeur 1 de ImagePGM\n";
	#endif
}

ImagePGM::ImagePGM(const char *pfileName)
{	
	FILE *filePtr;

	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans le constructeur 2 de ImagePGM\n";
	#endif
	filePtr = fopen(pfileName, "rb");
	if (filePtr)
	{
		LoadHeader(filePtr);
		Init(_nbColumn, _nbLine, PGM_NB_COMPONENT);
		Image<unsigned char>::Load(filePtr);
		fclose(filePtr);
	}
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie du constructeur 2 de ImagePGM\n";
	#endif
}


// Destructor
ImagePGM::~ImagePGM()
{
	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans le destructeur de ImagePGM\n";
	#endif
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie du destructeur de ImagePGM\n";
	#endif
}


// Method
int ImagePGM::Load(const char *pfileName)
{
	FILE *filePtr;
	
	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans la methode Load(const char *pfileName) de ImagePGM\n";
	#endif
	filePtr = fopen(pfileName, "rb");
	if (!filePtr) return 1;
	LoadHeader(filePtr);
	Image<unsigned char>::Load(filePtr);
	fclose(filePtr);
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie de la methode Load(const char *pfileName) de ImagePGM\n";
	#endif
	return 0;
}

int ImagePGM::Save(const char *pfileName) const
{
	char chaine[PGM_STRING_SIZE];
	FILE *filePtr;
	
	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans la methode Save(const char *pfileName) de ImagePGM\n";
	#endif
	filePtr = fopen(pfileName, "wb");
	if (!filePtr) return 1;
	fputs("P5\n", filePtr);
	sprintf(chaine, "%d %d\n", _nbColumn, _nbLine);
	fputs(chaine, filePtr);
	fputs("255\n", filePtr);
	Image<unsigned char>::Save(filePtr);
	fclose(filePtr);
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie de la methode Save(const char *pfileName) de ImagePGM\n";
	#endif
	return 0;
}

int ImagePGM::LoadHeader(FILE *pfilePtr)
{
	char ligne[PGM_STRING_SIZE];

	#ifdef PGM_DEBUG_MODE
		cout << "Entree dans la methode LoadHeader de ImagePGM\n";
	#endif
	fgets(ligne, PGM_STRING_SIZE, pfilePtr);
	fgets(ligne, PGM_STRING_SIZE, pfilePtr);
	while (ligne[0] == '#')
		/* Skip all the commented lines of the PGM file */
		fgets(ligne, PGM_STRING_SIZE, pfilePtr);
	sscanf(ligne, "%d%d", &_nbColumn, &_nbLine);
	fgets(ligne, PGM_STRING_SIZE, pfilePtr);
	#ifdef PGM_DEBUG_MODE
		cout << "Sortie de la methode LoadHeader de ImagePGM\n";
	#endif
	return 0;
}
