// Constructor
ImagePPM::ImagePPM(const int pnbColumn, const int pnbLine):
          Image<unsigned char>(pnbColumn, pnbLine, PPM_NB_COMPONENT)
{
	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans le constructeur 1 de ImagePPM\n";
	#endif
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie du constructeur 1 de ImagePPM\n";
	#endif
}

ImagePPM::ImagePPM(const char *pfileName)
{	
	FILE *filePtr;

	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans le constructeur 2 de ImagePPM\n";
	#endif
	filePtr = fopen(pfileName, "rb");
	if (filePtr)
	{
		LoadHeader(filePtr);
		Init(_nbColumn, _nbLine, PPM_NB_COMPONENT);
		Image<unsigned char>::Load(filePtr);
		fclose(filePtr);
	}
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie du constructeur 2 de ImagePPM\n";
	#endif
}


// Destructor
ImagePPM::~ImagePPM()
{
	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans le destructeur de ImagePPM\n";
	#endif
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie du destructeur de ImagePPM\n";
	#endif
}


// Method
int ImagePPM::Load(const char *pfileName)
{
	FILE *filePtr;
	
	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans la methode Load(const char *pfileName) de ImagePPM\n";
	#endif
	filePtr = fopen(pfileName, "rb");
	if (!filePtr) return 1;
	LoadHeader(filePtr);
	Image<unsigned char>::Load(filePtr);
	fclose(filePtr);
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie de la methode Load(const char *pfileName) de ImagePPM\n";
	#endif
	return 0;
}

int ImagePPM::Save(const char *pfileName) const
{
	char chaine[PPM_STRING_SIZE];
	FILE *filePtr;
	
	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans la methode Save(const char *pfileName) de ImagePPM\n";
	#endif
	filePtr = fopen(pfileName, "wb");
	if (!filePtr) return 1;
	fputs("P6\n", filePtr);
	sprintf(chaine, "%d %d\n", _nbColumn, _nbLine);
	fputs(chaine, filePtr);
	fputs("255\n", filePtr);
	Image<unsigned char>::Save(filePtr);
	fclose(filePtr);
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie de la methode Save(const char *pfileName) de ImagePPM\n";
	#endif
	return 0;
}

int ImagePPM::LoadHeader(FILE *pfilePtr)
{
	char ligne[PPM_STRING_SIZE];

	#ifdef PPM_DEBUG_MODE
		cout << "Entree dans la methode LoadHeader de ImagePPM\n";
	#endif
	fgets(ligne, PPM_STRING_SIZE, pfilePtr);
	fgets(ligne, PPM_STRING_SIZE, pfilePtr);
	while (ligne[0] == '#')
		/* Skip all the commented lines of the PGM file */
		fgets(ligne, PPM_STRING_SIZE, pfilePtr);
	sscanf(ligne, "%d%d", &_nbColumn, &_nbLine);
	fgets(ligne, PPM_STRING_SIZE, pfilePtr);
	#ifdef PPM_DEBUG_MODE
		cout << "Sortie de la methode LoadHeader de ImagePPM\n";
	#endif
	return 0;
}
