// Constructor
template <class T>
Image<T>::Image()
{
	#ifdef DEBUG_MODE
		cout << "Entree dans le constructeur 1 de Image\n";
	#endif
	#ifdef DEBUG_MODE
		cout << "Sortie du constructeur 1 de Image\n";
	#endif
}

template <class T>
Image<T>::Image(const int pnbColumn, const int pnbLine, const int pnbComponent)
{
	#ifdef DEBUG_MODE
		cout << "Entree dans le constructeur 2 de Image\n";
	#endif
	Init(pnbColumn, pnbLine, pnbComponent);
	#ifdef DEBUG_MODE
		cout << "Sortie du constructeur 2 de Image\n";
	#endif
}

template <class T>
Image<T>::Image(const int pnbColumn, const int pnbLine,
                const int pnbComponent, const char *pfileName)
{	
	#ifdef DEBUG_MODE
		cout << "Entree dans le constructeur 3 de Image\n";
	#endif
	Init(pnbColumn, pnbLine, pnbComponent);
	Load(pfileName);
	#ifdef DEBUG_MODE
		cout << "Sortie du constructeur 3 de Image\n";
	#endif
}


// Destructor
template <class T>
Image<T>::~Image()
{
	int i;
	
	#ifdef DEBUG_MODE
		cout << "Entree dans le destructeur de Image\n";
	#endif
	for (i=0; i<_nbLine; i++)
		delete [] _img[i];
	delete [] _img;
	#ifdef DEBUG_MODE
		cout << "Sortie du destructeur de Image\n";
	#endif
}


// Method
template <class T>
int Image<T>::Load(const char *pfileName)
{
	FILE *filePtr;
	
	#ifdef DEBUG_MODE
		cout << "Entree dans la methode Load(const char *pfileName) de Image\n";
	#endif
	filePtr = fopen(pfileName, "rb");
	if (!filePtr) return 1;
	Load(filePtr);
	fclose(filePtr);
	#ifdef DEBUG_MODE
		cout << "Sortie de la methode Load(const char *pfileName) de Image\n";
	#endif
	return 0;
}

template <class T>
int Image<T>::Save(const char *pfileName) const
{
	FILE *filePtr;
	
	#ifdef DEBUG_MODE
		cout << "Entree dans la methode Save(const char *pfileName) de Image\n";
	#endif
	filePtr = fopen(pfileName, "wb");
	if (!filePtr) return 1;
	Save(filePtr);
	fclose(filePtr);
	#ifdef DEBUG_MODE
		cout << "Sortie de la methode Save(const char *pfileName) de Image\n";
	#endif
	return 0;
}

template <class T>
int Image<T>::Init(const int pnbColumn, const int pnbLine,
                   const int pnbComponent)
{
	int i;

	#ifdef DEBUG_MODE
		cout << "Entree dans la methode Init de Image\n";
	#endif
	_nbColumn = pnbColumn;
	_nbLine = pnbLine;
	_nbComponent = pnbComponent;
	_img = new T*[_nbLine];
	if (!_img) return 1;
	for (i=0; i<_nbLine; i++)
	{
		_img[i] = new T[_nbColumn*_nbComponent];
		if (!_img[i])
		{
			for (i--; i>=0; i--)
				delete [] _img[i];
			delete [] _img;
			return 2;
		}
	}
	#ifdef DEBUG_MODE
		cout << "Sortie de la methode Init de Image\n";
	#endif
	return 0;
}

template <class T>
int Image<T>::Load(FILE *pfilePtr)
{
	int i;
	
	#ifdef DEBUG_MODE
		cout << "Entree dans la methode Load(FILE *pfilePtr) de Image\n";
	#endif
	for (i=0; i<_nbLine; i++)
		fread(_img[i], sizeof(T), _nbColumn*_nbComponent, pfilePtr);
	#ifdef DEBUG_MODE
		cout << "Sortie de la methode Load(FILE *pfilePtr) de Image\n";
	#endif
	return 0;
}

template <class T>
int Image<T>::Save(FILE *pfilePtr) const
{
	int i;
	
	#ifdef DEBUG_MODE
		cout << "Entree dans la methode Save(FILE *pfilePtr) de Image\n";
	#endif
	for (i=0; i<_nbLine; i++)
		fwrite(_img[i], sizeof(T), _nbColumn*_nbComponent, pfilePtr);
	#ifdef DEBUG_MODE
		cout << "Sortie de la methode Save(FILE *pfilePtr) de Image\n";
	#endif
	return 0;
}
