#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/fl_draw.H>
#include <iostream.h>
#include "Image.hxx"
#include "ImagePPM.hxx"

#ifndef exit
#include <stdlib.h>
#endif

class myWindow : public Fl_Window {

public:
  myWindow(char *nom):Fl_Window(0,0,nom)
    {
      imgprout = new ImagePPM(nom);
      size(imgprout->nbColumn(), imgprout->nbLine());
    };
  ~myWindow(){delete imgprout;};

protected:
  void draw()
    {
      for (int i=0;i<h();i++)
	fl_draw_image((*imgprout)[i],0,i,w(),1);
    };

private:
  Image<unsigned char> *imgprout;
};

int main(int argc, char **argv)
{
  int retour;
	
  if (argc != 2)
    {
      cout << "Utilisation : " << argv[0] << " <imagePPM>\n";
      exit(1);
    }
  myWindow *window = new myWindow(argv[1]);
  window->end();
  window->show();
  retour = Fl::run();
  delete window;
  return retour;
}
