/**
 * Filename : Complex.cxx
 * Description : Complex number class
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 **/
#include "Complex.hxx"

Complex::Complex(void) {
  re=0;
  im=0;
}

Complex::Complex(compType r,compType i) {
  re=r;
  im=i;
}
Complex::Complex(const Complex &c) {
  re = c.re;
  im = c.im;
}

Complex Complex::operator+(Complex v) {
  return Complex(re+v.re,im+v.im);
}

Complex Complex::operator-(Complex v) {
  return Complex(re-v.re,im-v.im);
}

Complex Complex::operator*(Complex v) {
  return Complex(re*v.re-im*v.im,re*v.im+im*v.re);
}


Complex Complex::operator/(compType v) {
  return Complex(re/v,im/v);
}

Complex Complex::operator=(Complex v) {
  return Complex(re=v.re,im=v.im);
}

compType Complex::norm() {
  return (compType)  sqrt( re*re+ im*im);
}

void Complex::raz() {
  re=0.0;
  im=0.0;
}

ostream& operator<<(ostream &os,Complex v) {
  os << v.re << "+i" << v.im << endl;
  return os;
}

istream& operator>>(istream &is,Complex &v) {
  is >> v.re >> v.im;
  return is;
}


 
