//_____________________________________________________________________________
/** <pre>
 * Filename : ImageAFM.cxx
 * Description : 
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/


#include "ImageAFM.hxx"


ImageAFM::ImageAFM(const char *pfileName) {	
  // debugf("... %s \n",pfileName);
  _header = NULL ;
  _header_size = 0;
  load(pfileName);
  // debugf("ImageAFM::ImageAFM(const char *pfileName) : over \n");
}

typeAfm ImageAFM::max() {
  if (_data==NULL) return 0;
  typeAfm v = (typeAfm)  _data[0][0];

  for (int i=0;i<_height;i++)
    for (int j=0;j<_width;j++)
      if (v<_data[i][j]) v= _data[i][j];
  return v;
}

typeAfm ImageAFM::min() {
  if (_data==NULL) return 0;
  typeAfm v = (typeAfm)  _data[0][0];

  for (int i=0;i<_height;i++)
    for (int j=0;j<_width;j++)
      if (v>_data[i][j]) v= _data[i][j];
  return v;
}

//-----------------------------------------------------------------------------


void ImageAFM::load(const char* fileName) {
  FILE *file;
  int w=0,h=0;

  typeAfm  buffer[512];

  debugf("void ImageAFM::load(%s) \n",fileName);

  if ((file=fopen(fileName,"rb"))==0) return; 
  // Code Erreur Ouverture fichier

  if (_data!=NULL) clean();
  //debugf(" lecture des parametres \n");
  fScanIntParam(file,"\\Data offset:",&_header_size);
  fScanIntParam(file,"\\Valid data len X:",&w);
  fScanIntParam(file,"\\Valid data len Y:",&h);

  //debugf(" initialisation de l'image : %d %d \n",w,h);
  init(w,h);

  debugf("... lit entete\n");
  fseek(file,0,SEEK_SET);
  delete[] _header ; _header = NULL ;
  _header = new char[_header_size];
  
  fread(_header,sizeof(char),_header_size,file);
  debugf("... lit entete : over \n");

  // repositionnement du pointeur de fichier / demarage donnee
  fseek(file,_header_size,SEEK_SET);

  // lecture des valeurs binaires
  for (int i=0;i<_height;i++) {
    fread(buffer,sizeof(typeAfm),_width,file);
    for (int j=0;j<_width;j++) {
      _data[i][j]=buffer[j];
      // debugf("<%d>",(int) _data[i][j]);
    }
  }

  // fermeture du fichier
  fclose(file);
  return; // Code erreur lecture OK
}
//-----------------------------------------------------------------------------
void ImageAFM::save(const char* fileName) {
  FILE *file;
  
  if ((file=fopen(fileName,"wb"))==0) return; 
  // Code Erreur Ouverture fichier
  fwrite(_header,sizeof(char),_header_size,file);
  // lecture des valeurs binaires
  for (int i=0;i<_height;i++) {
    fwrite(_data[i],sizeof(typeAfm),_width,file);
  }

  // fermeture du fichier
  fclose(file);
  return; // Code erreur lecture OK
}
//-----------------------------------------------------------------------------

ImageGray* ImageAFM::toImageGray(int gw,int gh) {
  debugf("ImageGray* ImageAFM::toImageGray(int gw,int gh) \n");
  ImageGray * im = new ImageGray(gw,gh);
  double t;
  for (int ih=0; ih<gh;ih++)
    for (int iw=0; iw<gw;iw++) {
      t = 255 *( double (this->getPix(iw,ih,gw,gh) + 32768 ))
	/  (double) 65535 ;
      (*im)[ih][iw] = (unsigned char) t;
    }
  return im;
}

/*
  int ImageAFM::get(int l,int c) {
  return _data[l][c];
}

void ImageAFM::set(int l,int c,float v) {
  _data[l][c]= (int) v;
}


int ImageAFM::getHeight() {
  return _height;
}

int ImageAFM::getWidth() {
  return _width;
}



void ImageAFM::clone(ImageAFM *img) {
  init(img->getWidth(),img->getHeight());
  if ((_width>0)&&(_height>0))
    for (int i=0;i<_width;i++)
      for (int j=0;j<_height;j++)
	_data[i][j]=img->_data[i][j];
}
*/

//_____________________________________________________________________________
