//_____________________________________________________________________________
/**
 * Filename : ImageAFM.hxx
 * Description : Image datatype for the AFM software
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/

#ifndef __ImageAFM__
#define __ImageAFM__
	
#include "ImageGeneric.hxx"
#include "ImageGray.hxx"

#include "strFile.h"
#include "string.h"

#define typeAfm short //__int16 // short // __int16 ??

class ImageAFM : public ImageGeneric <typeAfm> {

  /// members
public:
  char* _header;
  int _header_size;

public:
  ImageAFM();
  ImageAFM(const char* filename);
  ImageAFM(const int w, const int h) 
    : ImageGeneric<typeAfm>(w,h)
    { _header=NULL; _header_size=0; }
  
  ~ImageAFM() { delete _header; }

  /// methods  
  void load(const char* fileName);
  void save(const char* fileName);

  typeAfm max();
  typeAfm min();
  ImageGray *toImageGray( int gw, int gh);
  char * getHeader() { return _header; }
};
#endif
