//_____________________________________________________________________________
/**<pre>
 * Filename : ImageGeneric.hxx
 * Description : C++ template for Image data (2D Matrix)
 * @author Philippe_COVAL
 *</pre>
 **/

#ifndef __ImageGeneric__
#define __ImageGeneric__
	
#include <stdio.h>
	
template <class T>
class ImageGeneric {

  /** @name Attributes */

protected:    
  int _height;
  int _width;
  T **_data;

  // Cons/des/tructor
public:
  ImageGeneric(const int width , const int height);
  // copy constructor
  ImageGeneric(const ImageGeneric<T> &i) ;


  ~ImageGeneric();

protected:
  ImageGeneric();

  /** @name  Methods */
public:
  T *operator[](const int index ) {return _data[index];};
  T *getSignal1D();
  int getWidth(void) { return _width; };
  int getHeight(void) { return _height; };
  /** get the good pixel for a zoom display */
  T getPix(int w, int h, int wr, int wh ) ;
  int init(const int width, const int height );
  int clean();
};

#include "ImageGeneric_m.hxx"
#endif
//_____________________________________________________________________________
