//_____________________________________________________________________________
/** <pre>
 * Filename : ImageGeneric_m.hxx
 * Description : 
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/

#include <stdio.h>
#define debugf printf


//-----------------------------------------------------------------------------

// Constructor

template <class T>
ImageGeneric<T>::ImageGeneric() {
  _width = 0;
  _height = 0;
  _data = NULL;
  // debugf("ImageGeneric() : over\n");
}


// Copy constructor
template <class T>
ImageGeneric<T>::ImageGeneric(const ImageGeneric<T> &i) {
  int wm = i._width ;
  int hm = i._height ;
  init ( wm, hm);
  // y:\afm\sources\imagegeneric_m.hxx(31) : error C2678: binary '[' :
  // no operator defined which takes a left-hand operand of type 'const class ImageGeneric<short>'
  // (or there is no acceptable conversion)
  //  for (int h=0;h<hm;h++)
  //    for (int w=0;w<wm;w++)
  //      _data[h][w] = i[h][w];
}


template <class T>
ImageGeneric<T>::ImageGeneric(const int width, const int height) {
  init( width , height);
  //  debugf("ImageGeneric(const int width, const int height) : over \n");
}



// Destructor

template <class T>
ImageGeneric<T>::~ImageGeneric() {
  debugf("ImageGeneric<T>::~ImageGeneric() %d \n",_height);
  clean();
  //debugf("ImageGeneric<T>::~ImageGeneric() :over \n");
}

//-----------------------------------------------------------------------------



template <class T>
int ImageGeneric<T>::init(const int width, const int height ) {
  //debugf("... init : alloc image \");
  _width = width;
  _height = height;
  _data = new T* [_height];

  if (_data == NULL ) {
    debugf("Err!\n");
    return 1;
  }

  for (int i=0; i<_height; i++) {
    _data[i] = new T[_width];
    if (_data[i] == NULL ) {
      for (i--; i>=0; i--)
	delete [] (_data[i]);
      delete [] _data;
      debugf("Err!\n");
      return 2;
    }
  }
return 0;
}


template <class T>
int  ImageGeneric<T>::clean(){ 
  //debugf(" ImageGeneric<T>::clean()\n");
  if (_data != NULL) {
    for (int i=0;i<_height;i++)
      delete[] _data[i];
    delete[] _data;
    _data=NULL;
  }
  //debugf(" ImageGeneric<T>::clean() : over\n");

  return 0;
} 
/**
 * zoom routine
 **/
template <class T>
T ImageGeneric<T>::getPix(int iw, int ih, int rw, int rh) {
  //debugf("T ImageGeneric<T>::getPix(%d %d %d %d)  \n",iw,ih,rw,rh);
  int pw,ph;
  ph = int ( float (ih* (_height -1))  / (float) rh );
  pw = int ( float (iw* (_width -1 ))  / (float) rw );
	
  return _data[ph][pw];
}
//_____________________________________________________________________________
