//_____________________________________________________________________________
/** <pre>
 * Filename : ImageGray.cxx
 * Description : 
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/

#include "ImageGray.hxx"
#define BUF 1024
#define debugf printf
//-----------------------------------------------------------------------------

ImageGray::ImageGray(const char *pfileName) {	
  FILE *filePtr;
  printf("... %s \n",pfileName);
  filePtr = fopen(pfileName, "rb");
  if (filePtr) {
    getPNMInfos(filePtr);
    fclose(filePtr);
    init( _width, _height);
    loadPNM(pfileName);
  }
}

//-----------------------------------------------------------------------------

int ImageGray::getPNMInfos(FILE *pfilePtr) {
  char ligne[BUF];
  
  fgets(ligne, BUF, pfilePtr);
  fgets(ligne, BUF, pfilePtr);
  /* Skip all the commented lines of the PGM file */
  while (ligne[0] == '#')
    fgets(ligne, BUF, pfilePtr);

  sscanf(ligne, "%d%d", &_width, &_height);
  fgets(ligne, BUF, pfilePtr);
  return 0;
}

//-----------------------------------------------------------------------------

void ImageGray::savePNM(const char *filename) {

  int t;
  FILE *f;
  debugf("... writing \n");
  if (! (f = fopen(filename,"wt")) )
    perror("I/O er");

  debugf("... writing \n");
  
  fprintf(f,"P2\n");
  fprintf(f,"# Greyscale Image * http://i.am/rzr\n");
  fprintf(f,"%d %d\n",_width,_height);
  fprintf(f,"255\n");

  for (int h=0;h<_height;h++) {
    for(int w=0;w<_width;w++) {
      for(int d=0;d<1;d++) {
	//	if ( (size = _width) > 16 ) size=16;
	//        if ( (adr % size) == 0)
	//          fprintf(f,"\n");
        t = (int) _data[h][w];
	if (t<0) {t=0; //printf("!!! <%d>",t);
	}
	if (t > 99)      fprintf(f,"%d ",t);
	else
	  if (t > 9)      fprintf(f," %d ",t);
	  else             fprintf(f,"  %d ",t);
      }
    }
  }
  fprintf(f,"\n");
  fclose(f);
}

//-----------------------------------------------------------------------------
/**
 * PNM format in ascii != raw
 **/
void ImageGray::loadPNM(const char *filename) {
  FILE *f;
  int d;
  int t_uc;
  int l,c;
 

  if (! (f = fopen(filename,"rt")) )
    perror("I/O er");
  getPNMInfos(f);  
  for(l=0;l<_height;l++) {
    for(c=0;c<_width;c++) 
      for(d=0;d<1;d++) {
	fscanf(f,"%d",&t_uc );
	_data[l][c] = t_uc ;
      }
  }
  fclose (f);
}


//-----------------------------------------------------------------------------

void ImageGray::zoom(const int w, const int h) {

  ImageGray *i=new ImageGray(w,h);

  float rc = (float) this->getWidth() / (float) w;
  float rl = (float) this->getHeight() / (float) h;

  //  debugf("... zoom : %f %f \n",rc, rl);
  int il,ic;

  for (int l=0;l<h;l=l++) {
    for (int c=0;c<w;c++){
      il = (int) ( (float) l * rl) ;
      ic = (int) ( (float) c * rc) ;
      (*i)[l][c] = _data[il][ic] ;
    } }
  delete	this->_data ; this->_data = NULL ;
  this->_data = i->_data ;
  this->_height = h;
  this->_width = w ;
  // return i;
}
//_____________________________________________________________________________
