//_____________________________________________________________________________
/**
 * Filename : Imgwidget.cxx
 * Description : FLTK grayscale display
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 **/

#include "Imgwidget.hxx"
#include <FL/Fl_Window.H>
#define debugf printf


Imgwidget::Imgwidget(int x, int y ,int w ,int h, char* s) :Fl_Box(x,y,w,h) {
  _w = w;
  _h = h;
  _img = NULL;
};

void Imgwidget::draw() {
  short x_,y_,w_,h_,d_;

  debugf("Imgwidget::draw() \n");
  if ( this->_img == NULL) return;

  //  window()->make_current()  ;


  x_ = x() + window()->x(); 
  y_ = y() + window()->y();
  w_ = w();
  h_ = h();
  size(w_,h_);
  d_ = 1;

  if ( ( _img->getWidth() != w() ) 
       || ( _img->getHeight() != h() ) ) {
    _img->zoom( w() , h() ); 
  }

  
  for (int l=0;l<h_;l=l++) 
    fl_draw_image_mono((*_img)[l],x_,y_+l,w_,1);
  debugf("void Imgwidget::draw() : ok \n");  
};

//_____________________________________________________________________________
