//_____________________________________________________________________________
/** <pre>
 * Filename : Signalwidget.hxx
 * Description : FLTK widget for showing 1D-signal as 2D-Image
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/
//#include <Fl/Fl_window.H>
#include "Signalwidget.hxx"
#define debugf printf


void Signalwidget::dispThreshold() {
  //debugf("dispThreshold \n");
  delete _img; _img= NULL;
  _img = _sig->getImageThreshold( _iw , _ih );
  redraw();
  show();
  //debugf("dispThreshold : over\n");
}


void Signalwidget::dispDyn() {
  //debugf("dispDyn\n");
  delete _img; _img=NULL;
  _img = _sig->getImageDyn(_iw,_ih);
  redraw();
  show();
  //debugf("dispDyn : ok \n");
}

void Signalwidget::cleanAFM() {
  if ( _sig != NULL ) {
    delete (_sig->_iref_afm );
    _sig->_iref_afm = NULL ;
  }	
}
/*
void Signalwidget::clean() {
	//debugf("void Signalwidget::clean()\n");
	//debugf(".. wait for drawing is over\n");
//	hide();
//	Fl_Group::current()->end();
	window()->end();
	Fl::flush();
//	Fl_Box::redraw();
//	if ( ! Fl::ready()) 	{
//		debugf(" ! ready \n");
//		Fl::flush();
//	}
	  Fl::check();
	 // Fl::wait(10);

	//debugf("deleting \n");
	delete _img;		_img=NULL;
	//delete _sig;		_sig=NULL;
	//debugf("show\n");
//	show();
	//debugf("void Signalwidget::clean() {:over \n");
}
*/
void Signalwidget::clean() {
  //window()->end();
  //Fl::flush();
  //	Fl::check();
  //	debugf("delete sig %s \n",_sig);
  //	delete _sig;		_sig=NULL;
  //		debugf("delete sig :ok \n");

  delete _img;		_img=NULL;

}


void Signalwidget::setSignal( ImageAFM &img) {
  clean();
  _sig   = new Signal1D(img);
}

void Signalwidget::setSignal( ImageGray &img) {
  clean();
  _sig   = new Signal1D(img);
}
//_____________________________________________________________________________
