//_____________________________________________________________________________
/** <pre>
 * Filename : Signalwidget.hxx
 * Description : FLTK widget for showing 1D-signal as 2D-Image
 * @author: Philippe COVAL (http://RzR.online.FR) & Frederic MORALES
 * Date: 2000.02.20
 * </pre>
 **/

#ifndef __Signalwidget__
#define __Signalwidget__

#include "Imgwidget.hxx"
#include "Signal1D.hxx"
#include "ImageAFM.hxx"
#include "ImageGray.hxx"


//-----------------------------------------------------------------------------

class   Signalwidget : public Imgwidget {

  /// class members
public:
  Signal1D *_sig ;
  int _iw, _ih;

  /// con/de/structor
  Signalwidget(int x, int y ,int w ,int h, char* s) : 
    Imgwidget(x,y,w,h,s) { _sig = NULL; } 
  ~Signalwidget(){ };
 
  // methods
 
  void clean();
  void cleanAFM();
  void dispThreshold();
  void dispDyn();
  void setSignal (ImageAFM & img);
  void setSignal (ImageGray & img);
	
};
#endif
